#!/bin/sh
# (c) 2004 Cyanea Systems Corp.
# All Rights Reserved

# Set environment variables.


if [ -z "$WSAMBIN" ]
then
        myDir=`dirname ${0}`
else
        myDir="$WSAMBIN"
fi

OS=`uname`
if [ "$OS" = "Windows" ]; then
        echo "This script can not run without a shell envirnment."
        echo "Aborting..."
        exit 50
elif [ "$OS" = "Interix" ]; then
        oldDir=`pwd`
        cd $myDir
        . ./setenv.sh
else
        if [ -f ${myDir}/setenv.sh ]
        then
                . ${myDir}/setenv.sh
        fi
fi



find_procs() 
{
  OS=`uname`
  case $OS in 
    Linux )
    PID_CMD="ps auxww | grep DataTrimmer |grep start| grep -v grep ";
  ;;
    AIX)
    PID_CMD="( export COLUMNS=5000 ; ps -eaf | grep DataTrimmer | grep  start  | grep -v grep )";
  ;;
    SunOS )
    PID_CMD="/usr/ucb/ps -auxww | grep DataTrimmer| grep  start |  grep -v grep ";
  ;;
  Interix )
    PID_CMD="ps -eafwXunix | grep DataTrimmer | grep start | grep -v grep";
  ;;

  esac

  FIND_PID=`eval ${PID_CMD} | awk '{print $2 }'`
  export FIND_PID
}



COMMAND=$1

#if [ "$COMMAND" = "" ] ; then
#  COMMAND=ping
#fi

DATATRIMMER_PROPERTIES=datatrimmer
  LOG_DATATRIMMER_PROPERTIES=log-datatrimmer.properties

DATATRIMMER_NAME=`basename datatrimmer.properties`

case $COMMAND in
    start) 
        find_procs DataTrimmer
        if [ "$FIND_PID" != "" ] ; then
            echo "DataTrimmer has already been started on this machine ";
            exit 1;
        fi
        echo "starting datatrimmer "
	
	if [ "$OS" = "Interix" ]; then

CLASSPATH=${JDBC_DRIVER_JAR}
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar;."
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\j2ee.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\migration.jar"

else

        CLASSPATH=.
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/migration.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/common.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/cyaneaaux.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/etc
        CLASSPATH=${CLASSPATH}:${JDBC_DRIVER_JAR}
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/j2ee.jar

fi

        if [ "$HEAP_MIN_SIZE_DATATRIMMER" = "" ] ; then
	   HEAP_MIN_SIZE_DATATRIMMER=256
        fi
        if [ "$HEAP_MAX_SIZE_DATATRIMMER" = "" ] ; then
	   HEAP_MAX_SIZE_DATATRIMMER=256
        fi


        ${JAVA_HOME}/bin/${JAVA_CMD} -classpath ${CLASSPATH}  -DJDBC_DRIVER_NAME=${JDBC_DRIVER_NAME}  -DDB_URL=${JDBC_DRIVER_URL}  -DDB_USER=${JDBC_USER}  -DDB_PASSWORD=${JDBC_PASSWORD}  -Dcyanea.log.properties=${LOG_DATATRIMMER_PROPERTIES}  -Ddatatrimmer.propResource=datatrimmer.properties  -Xms${HEAP_MIN_SIZE_DATATRIMMER}m  -Xmx${HEAP_MAX_SIZE_DATATRIMMER}m  com.cyanea.datatrimmer.DataTrimmer $@ &
    	DATATRIMMER_PID=$!
    	if [ "$DATATRIMMER_PID_FILE" = "" ] ; then
      		DATATRIMMER_PID_FILE=/tmp/`basename datatrimmer.properties`.pid
    	fi
    	echo $DATATRIMMER_PID > $DATATRIMMER_PID_FILE
    ;;
    dbtest) 
        echo "testing database connectionwith datatrimmer properties...";
       if [ "$OS" = "Interix" ]; then

CLASSPATH=${JDBC_DRIVER_JAR}
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar;."
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\j2ee.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\migration.jar"

else

	CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/common.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/cyaneaaux.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/kernel.common.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/etc
        CLASSPATH=${CLASSPATH}:${JDBC_DRIVER_JAR}
	fi
        ${JAVA_HOME}/bin/${JAVA_CMD} -classpath $CLASSPATH \
            -DJDBC_DRIVER_NAME=COM.ibm.db2.jdbc.app.DB2Driver \
            -DDB_URL=jdbc:db2:octigate \
            -DDB_USER= \
            -DDB_PASSWORD= \
            -Ddatatrimmer.propResource=datatrimmer \
            -Dcyanea.log.properties=${LOG_DATATRIMMER_PROPERTIES} \
            com.cyanea.common.dbtest.DBTest datatrimmer $@; 
    ;;
    dumpcore)
     echo "dumping core... ";
     if [ "$DATATRIMMER_PID_FILE" = "" ] ; then
        DATATRIMMER_PID_FILE=/tmp/`basename datatrimmer.properties`.pid
     fi
     DATATRIMMER_PID=`cat $DATATRIMMER_PID_FILE`
     echo "Dumping PID ${DATATRIMMER_PID}"
     kill -3 `cat $DATATRIMMER_PID_FILE`
   ;;
     ping | status  )
        echo "contacting datatrimmer ";
	if [ "$OS" = "Interix" ]; then

CLASSPATH=${JDBC_DRIVER_JAR}
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar;."
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\j2ee.jar"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\migration.jar"

else

        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/migration.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/common.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/lib/cyaneaaux.jar
        CLASSPATH=${CLASSPATH}:${CYANEA_HOME}/etc
fi

        ${JAVA_HOME}/bin/$JAVA_CMD -classpath $CLASSPATH \
            -Dcyanea.log.properties=${LOG_DATATRIMMER_PROPERTIES} \
            -Ddatatrimmer.propResource=datatrimmer.properties \
            com.cyanea.datatrimmer.DataTrimmer $@;
    ;;    
    killall | forcestop |stop) 
        find_procs DataTrimmer DataTrimmer
        echo "killing -9 all DataTrimmer  processes";
        if [ "$FIND_PID" = "" ] ; then
            echo "DataTrimmer  does not appear to be running, (no processes found)."
            exit 1;
        fi;
        kill -9  $FIND_PID;
    ;;
    *) 
        echo "usage: datatrimmer.sh ( start | stop |dumpcore )";
        echo "  start      - start datatrimmer ";
        echo "  stop       - stop datatrimmer ";
        echo "  dumpcore   - dump java core for the datatrimmer proccess";
    ;;
esac
if [ "$OS" = "Interix" ]; then
        cd $oldDir
fi
