#!/bin/sh
#
# Licensed Materials - Property of IBM
# 5724-L62
#
# (C) Copyright IBM Corp. 2005  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# @(#)93   1.1.1.3   messagedispatcher/src/bin/mdctl.sh, am_messagedispatcher, claret, 20050211010008 2/11/05 00:19:09
#
# (c) 2002-2004 Cyanea Systems Corp.
# All Rights Reserved
#

if [ -z "$WSAMBIN" ]
then
        myDir=`dirname ${0}`
else
        myDir="$WSAMBIN"
fi

OS=`uname`
if [ "$OS" = "Windows" ]; then
	echo "This script can not run without a shell envirnment."
	echo "Aborting..."
	exit 50
elif [ "$OS" = "Interix" ]; then
	oldDir=`pwd`
	cd $myDir	
	. ./setenv.sh
else
	if [ -f ${myDir}/setenv.sh ]
	then
        	. ${myDir}/setenv.sh
	fi
fi

find_procs() 
{
  OS=`uname`
  case $OS in 
    Linux )
    PID_CMD="ps auxww | grep '$1 start' | grep $2 | grep -v grep ";
  ;;
    AIX)
    PID_CMD="( export COLUMNS=5000 ; ps -eaf | grep '$1 start' | grep $2 | grep -v grep )";
  ;;
    SunOS )
    PID_CMD="/usr/ucb/ps -auxww | grep '$1 start' | grep $2 | grep -v grep ";
  ;;
    Interix )
    PID_CMD="ps -eafwXunix | grep '$1 start' | grep $2 | grep -v grep";
  ;;
  esac

  FIND_PID=`eval ${PID_CMD} | awk '{ print $2 }'`
  export FIND_PID
}

CODEBASE_ADDRESS01=$KERNEL_HOST01:$PORT_KERNEL_CODEBASE01
CODEBASE_ADDRESS02=$KERNEL_HOST02:$PORT_KERNEL_CODEBASE02

COMMAND=$1

#if [ "$COMMAND" = "" ] ; then
#   COMMAND=ping
#fi

MESSAGE_DISPATCHER_PROPERTIES=$2
if [ "$MESSAGE_DISPATCHER_PROPERTIES" = "" ] ; then
   MESSAGE_DISPATCHER_PROPERTIES=md.properties
fi

if [ "$LOG_MESSAGE_DISPATCHER_PROPERTIES" = "" ] ; then
   LOG_MESSAGE_DISPATCHER_PROPERTIES=log-`basename ${MESSAGE_DISPATCHER_PROPERTIES}`
fi

case $COMMAND in
    start) 
	find_procs TrapDispatcherController ${MESSAGE_DISPATCHER_PROPERTIES}
        if [ "$FIND_PID" != "" ] ; then
            echo "Message Dispatcher has already been started on this machine";
            exit 1;
        fi
	CODEBASE_ADDRESS01=$KERNEL_HOST01:$PORT_KERNEL_CODEBASE01
	CODEBASE_ADDRESS02=$KERNEL_HOST02:$PORT_KERNEL_CODEBASE02

	if [ "$OS" = "Interix" ]; then
		CLASSPATH=${JDBC_DRIVER_JAR}
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\kernel.common.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\messagedispatcher.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\messagedispatcher-intf.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.publish.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.publish-intf.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
	else
 		CLASSPATH=$CLASSPATH:/server/lib/weblogic.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/kernel.common.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/messagedispatcher.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/messagedispatcher-intf.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/common.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/cyaneaaux.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.publish.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.publish-intf.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/etc
	fi
	$JAVA_HOME/bin/$JAVA_CMD -Xms${HEAP_MIN_SIZE_MESSAGE_DISPATCHER}m -Xmx${HEAP_MAX_SIZE_MESSAGE_DISPATCHER}m -classpath $CLASSPATH \
                -Dcomponent.listen.port=${PORT_MESSAGE_DISPATCHER} \
                -Dtemplate.directory=${CYANEA_HOME_OS}/etc \
        	-Djava.security.policy=$CYANEA_HOME_OS/etc/md.policy \
        	-Dkernel.codebase="http://$CODEBASE_ADDRESS01/kernel.core.jar http://$CODEBASE_ADDRESS02/kernel.core.jar" \
        	-Dkernel.rfs.address="$KERNEL_HOST01:$PORT_KERNEL_RFS01 $KERNEL_HOST02:$PORT_KERNEL_RFS02" \
        	-Djava.rmi.server.codebase="http://$CODEBASE_ADDRESS01/messagedispatcher.jar http://$CODEBASE_ADDRESS01/messagedispatcher-intf.jar http://$CODEBASE_ADDRESS02/messagedispatcher.jar http://$CODEBASE_ADDRESS02/messagedispatcher-intf.jar" \
		-Dcyanea.log.properties=${LOG_MESSAGE_DISPATCHER_PROPERTIES} \
		-Dproperties.filename=${MESSAGE_DISPATCHER_PROPERTIES} \
		-Dcertificate.path=$CERT_PATH \
                -Dkeystore.location=$KEYSTR_LOC \
                -Dkeystore.storepass=$KEYSTR_PASS \
                -Dkeystore.keypass=$KEYSTR_KEYPASS \
                -Dnodeauth.userid=$NODE_USERID \
                -Dnodeauth.ip=$NODE_IP \
        	com.cyanea.trapdispatcher.TrapDispatcherController $@  2>>$CYANEA_HOME/logs/am_stderr.log | tee -a $CYANEA_HOME/logs/am_stdout.log &
    ;;
    stop | ping | status | warn | debug | info )
        echo "Contacting Message Dispatcher...";
	CODEBASE_ADDRESS01=$KERNEL_HOST01:$PORT_KERNEL_CODEBASE01
	CODEBASE_ADDRESS02=$KERNEL_HOST02:$PORT_KERNEL_CODEBASE02
	if [ "$OS" = "Interix" ]; then
		CLASSPATH=${JDBC_DRIVER_JAR}
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\kernel.common.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\messagedispatcher.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\messagedispatcher-intf.jar"
		CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
	else
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/kernel.common.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/messagedispatcher.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/messagedispatcher-intf.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/common.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/cyaneaaux.jar
		CLASSPATH=$CLASSPATH:$CYANEA_HOME/etc
	fi
	$JAVA_HOME/bin/$JAVA_CMD -Xms${HEAP_MIN_SIZE_MESSAGE_DISPATCHER}m -Xmx${HEAP_MAX_SIZE_MESSAGE_DISPATCHER}m -classpath $CLASSPATH \
        	-Djava.security.policy=$CYANEA_HOME_OS/etc/md.policy \
                -Dcomponent.listen.port=${PORT_MESSAGE_DISPATCHER} \
                -Dtemplate.directory=${CYANEA_HOME_OS}/etc \
        	-Dkernel.codebase="http://$CODEBASE_ADDRESS01/kernel.core.jar http://$CODEBASE_ADDRESS02/kernel.core.jar" \
        	-Dkernel.rfs.address="$KERNEL_HOST01:$PORT_KERNEL_RFS01 $KERNEL_HOST02:$PORT_KERNEL_RFS02" \
        	-Djava.rmi.server.codebase="http://$CODEBASE_ADDRESS01/messagedispatcher.jar http://$CODEBASE_ADDRESS02/messagedispatcher.jar " \
		-Dcyanea.log.properties=${LOG_MESSAGE_DISPATCHER_PROPERTIES} \
		-Dproperties.filename=${MESSAGE_DISPATCHER_PROPERTIES} \
		-Dcertificate.path=$CERT_PATH \
                -Dkeystore.location=$KEYSTR_LOC \
                -Dkeystore.storepass=$KEYSTR_PASS \
                -Dkeystore.keypass=$KEYSTR_KEYPASS \
                -Dnodeauth.userid=$NODE_USERID \
                -Dnodeauth.ip=$NODE_IP \
        	com.cyanea.trapdispatcher.TrapDispatcherController $@ 
    ;;    
    forcestop | killall )
	find_procs TrapDispatcherController TrapDispatcherController
        echo "killing -9 all Message Dispatcher processes";
        if [ "$FIND_PID" = "" ] ; then
            echo "Message Dispatcher does not appear to be running, (no processes found)."
            exit 1;
        fi;
        kill -9  $FIND_PID;
    ;;
    *) 
        echo "usage: mdctl ( start | stop | forcestop | debug | warn | info | ping | status | help )";
        echo "  start      - start Messages Dispatcher";
        echo "  stop       - stop Message Dispatcher";
        echo "  forcestop  - forcestop Message Dispatcher";
        echo "  debug      - switch to debugging mode";
        echo "  warn       - switch to warning mode";
        echo "  info       - switch to informative mode";
        echo "  ping       - ping Message Dispatcher to see if it is alive";
        echo "  status     - retrieve Message Dispatcher status";
        echo "  help       - view this info";
    ;;
esac

if [ "$OS" = "Interix" ]; then
	cd $oldDir
fi

