#!/bin/sh
#
# Licensed Materials - Property of IBM
# 5724-L62
#
# (C) Copyright IBM Corp. 2005  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# @(#)02   1.1.1.3   ppe.publish/src/bin/psctl.sh, am_ppe.publish, claret, 20050211010008 2/11/05 00:19:13
#
# (c) 2002-2004 Cyanea Systems Corp.
# All Rights Reserved
#

# Set environment variables.

if [ -z "$WSAMBIN" ]
then
        myDir=`dirname ${0}`
else
        myDir="$WSAMBIN"
fi

myName=`basename ${0}`

OS=`uname`
if [ "$OS" = "Windows" ]; then
	echo "This script can not run without a shell envirnment."
	echo "Aborting..."
	exit 50
elif [ "$OS" = "Interix" ]; then
	oldDir=`pwd`
	cd $myDir	
	. ./setenv.sh
else
	if [ -f ${myDir}/setenv.sh ]
	then
        	. ${myDir}/setenv.sh
	fi
fi


find_procs() 
{
  OS=`uname`
  case $OS in 
    Linux )
    PID_CMD="ps auxww | grep '$1 start' | grep $2 | grep -v grep ";
  ;;
    AIX)
    PID_CMD="( export COLUMNS=5000 ; ps -eaf | grep '$1 start' | grep $2 | grep -v grep )";
  ;;
    SunOS )
    PID_CMD="/usr/ucb/ps -auxww | grep '$1 start' | grep $2 | grep -v grep ";
  ;;
    Interix )
    PID_CMD="ps -eafwXunix | grep '$1 start' | grep $2 | grep -v grep";
  ;;
  esac

  FIND_PID=`eval ${PID_CMD} | awk '{ print $2 }'`
  export FIND_PID
}

if [ "$OS" = "Interix" ]; then
	CLASSPATH=${JDBC_DRIVER_JAR}
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\cyaneaaux.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\common.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\kernel.common.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\model.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.publish.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.publish-intf.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\sam.gps-intf.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\sam.gps.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.probe-intf.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\ppe.pmi.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\archiveagent-intf.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\eventbus.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\lib\\messagedispatcher-intf.jar"
	CLASSPATH="$CLASSPATH;$CYANEA_HOME_OS\\etc"
else
	CLASSPATH=.
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/kernel.common.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/common.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/etc
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.publish.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.publish-intf.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/sam.gps-intf.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.probe-intf.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/messagedispatcher-intf.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/ppe.pmi.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/archiveagent-intf.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/eventbus.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/model.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/cyaneaaux.jar
	CLASSPATH=$CLASSPATH:/server/lib/weblogic.jar
	CLASSPATH=$CLASSPATH:$CYANEA_HOME/lib/sam.gps.jar
fi

COMMAND=$1

#if [ "$COMMAND" = "" ] ; then
#   COMMAND=ping
#fi

### Process option command arguments
PS_PROPERTIES=$2
if [ "$PS_PROPERTIES" = "" ] ; then
   PS_PROPERTIES=ps.properties
fi

LOG_PS_PROPERTIES=$3
if [ "$LOG_PS_PROPERTIES" = "" ] ; then
   LOG_PS_PROPERTIES=log-${PS_PROPERTIES}
fi

PS_NAME=`basename ${PS_PROPERTIES} .properties`
if [ "$PS_NAME" = "ps2" ] ; then
  PS_LISTEN_PORT=${PORT_PS2}
else
  PS_LISTEN_PORT=${PORT_PS}
fi


DIRECT_ARGS="$3 $4"

RMI_CODEBASE="http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/ppe.publish-intf.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/ppe.publish-intf.jar http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/ppe.publish.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/ppe.publish.jar http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/model.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/model.jar  http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/ppe.probe-intf.jar http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/kernel.common.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/kernel.common.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/ppe.probe-intf.jar" 
export RMI_CODEBASE

SECURITY_POLICY=${CYANEA_HOME_OS}/etc/ps.policy
export SECURITY_POLICY

KERNEL_CODEBASE="http://${KERNEL_HOST01}:${PORT_KERNEL_CODEBASE01}/kernel.core.jar http://${KERNEL_HOST02}:${PORT_KERNEL_CODEBASE02}/kernel.core.jar"
export KERNEL_CODEBASE

KERNEL_RFS_ADDRESS="${KERNEL_HOST01}:${PORT_KERNEL_RFS01} ${KERNEL_HOST02}:${PORT_KERNEL_RFS02}"
export KERNEL_RFS_ADDRESS

case $COMMAND in 
  start)
   find_procs PsCtl ${PS_PROPERTIES}
   if [ "$FIND_PID" != "" ] ; then
            echo "Publish Server has already been started on this machine for property file ${PS_PROPERTIES}";
            exit 1;
   fi
   echo "starting PublishServer..."
   if [ "$HEAP_MIN_SIZE_PS" = "" ] ; then
     HEAP_MIN_SIZE_PS=128
   fi
   if [ "$HEAP_MAX_SIZE_PS" = "" ] ; then
     HEAP_MAX_SIZE_PS=128
   fi
   $JAVA_HOME/bin/$JAVA_CMD -classpath $CLASSPATH \
        -DPORT_PS=${PS_LISTEN_PORT} \
        -Djava.rmi.server.codebase="${RMI_CODEBASE}" \
        -Djava.security.policy=${SECURITY_POLICY} \
        -Dkernel.codebase="${KERNEL_CODEBASE}" \
        -Dkernel.rfs.address="${KERNEL_RFS_ADDRESS}" \
        -Dps.propResource=${PS_PROPERTIES} \
        -Dcyanea.log.properties=${LOG_PS_PROPERTIES} \
        -Xms${HEAP_MIN_SIZE_PS}m \
        -Xmx${HEAP_MAX_SIZE_PS}m \
	-Dcertificate.path=$CERT_PATH \
        -Dkeystore.location=$KEYSTR_LOC \
        -Dkeystore.storepass=$KEYSTR_PASS \
        -Dkeystore.keypass=$KEYSTR_KEYPASS \
        -Dnodeauth.userid=$NODE_USERID \
        -Dnodeauth.ip=$NODE_IP \
    com.cyanea.publish.PsCtl start   2>>$CYANEA_HOME/logs/am_stderr.log | tee -a $CYANEA_HOME/logs/am_stdout.log &
    PSCTL_PID=$!
    if [ "$PSCTL_PID_FILE" = "" ] ; then
      PSCTL_PID_FILE=/tmp/`basename ${PS_PROPERTIES} .properties`.pid
    fi
    echo $PSCTL_PID > $PSCTL_PID_FILE
   ;;
   forcestop | killall ) 
        find_procs PsCtl PsCtl
        echo "killing -9 all PublishServer processes ${FIND_PID}";
        if [ "$FIND_PID" = "" ] ; then
            echo "Publish Server does not appear to be running, (no processes found)."
            exit 1;
        fi;
        kill -9  $FIND_PID;
    ;;
   dumpcore)
     if [ "$PSCTL_PID_FILE" = "" ] ; then
        PSCTL_PID_FILE=/tmp/`basename ${PS_PROPERTIES} .properties`.pid
     fi
     PSCTL_PID=`cat $PSCTL_PID_FILE`
     echo "Dumping PID ${PSCTL_PID}"
     kill -3 `cat $PSCTL_PID_FILE`
   ;;
   stop)
     $JAVA_HOME/bin/$JAVA_CMD -classpath $CLASSPATH \
        -DPORT_PS=${PS_LISTEN_PORT} \
        -Djava.rmi.server.codebase="${RMI_CODEBASE}" \
        -Djava.security.policy=${SECURITY_POLICY} \
        -Dkernel.codebase="${KERNEL_CODEBASE}" \
        -Dkernel.rfs.address="${KERNEL_RFS_ADDRESS}" \
        -Dps.propResource=${PS_PROPERTIES} \
        -Dcyanea.log.properties=${LOG_PS_PROPERTIES} \
	 -Dcertificate.path=$CERT_PATH \
        -Dkeystore.location=$KEYSTR_LOC \
        -Dkeystore.storepass=$KEYSTR_PASS \
        -Dkeystore.keypass=$KEYSTR_KEYPASS \
        -Dnodeauth.userid=$NODE_USERID \
        -Dnodeauth.ip=$NODE_IP \
    com.cyanea.publish.PsCtl ${COMMAND}  
   ;;
   ping | status | debug | info | warn)
    $JAVA_HOME/bin/$JAVA_CMD -classpath $CLASSPATH \
        -DPORT_PS=${PS_LISTEN_PORT} \
        -Djava.rmi.server.codebase="${RMI_CODEBASE}" \
        -Djava.security.policy=${SECURITY_POLICY} \
        -Dkernel.codebase="${KERNEL_CODEBASE}" \
        -Dkernel.rfs.address="${KERNEL_RFS_ADDRESS}" \
        -Dps.propResource=${PS_PROPERTIES} \
        -Dcyanea.log.properties=${LOG_PS_PROPERTIES} \
	 -Dcertificate.path=$CERT_PATH \
        -Dkeystore.location=$KEYSTR_LOC \
        -Dkeystore.storepass=$KEYSTR_PASS \
        -Dkeystore.keypass=$KEYSTR_KEYPASS \
        -Dnodeauth.userid=$NODE_USERID \
        -Dnodeauth.ip=$NODE_IP \
    com.cyanea.publish.PsCtl ${COMMAND}  ${DIRECT_ARGS}
   ;; 
   *)
     echo "${myName}: Usage: $myName ( start | stop | ping | status | fullstop | dumpcore | debug | info | warn )"
   ;;
esac

if [ "$OS" = "Interix" ]; then
	cd $oldDir
fi

